import { Component, ViewChild, OnInit,Inject } from '@angular/core';
import * as wjCore from 'wijmo/wijmo';
import * as wjOlap from "wijmo/wijmo.olap";
import {DataSvc} from "./services/DataSvc";
import { Element } from '@angular/compiler';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent{
  public data:wjCore.CollectionView;
  constructor(@Inject(DataSvc) _dataSvc:DataSvc){
    this.data= new wjCore.CollectionView(_dataSvc.getData(100));
    View.updateView();
  }
  @ViewChild("thePanel") panel:wjOlap.PivotPanel;
  ngAfterViewInit(){
    window.onresize=()=>{
      setTimeout(()=>{
        View.updatePanelView(this.panel);
      },10)
    }
    setTimeout(()=>{
      View.updatePanelView(this.panel);
      document.querySelector('[wj-part="g-defer"]').parentElement.onclick=()=>{
        setTimeout(()=>{
          View.updatePanelView(this.panel); 
        },10)
      }
    },10)
    this.panel.updatedView.addHandler((s,e)=>{
      View.updatePanelView(this.panel);
    })
  }

}

class View{
  public static updateView(){
    wjOlap.PivotPanel.controlTemplate='<div >' +
    '<div style="display:flex">' +
  
        // fields
        '<div>' +
            '<label wj-part="g-flds"></label>' +
            '<div wj-part="d-fields" ></div>' +
        '</div>' +
  
        // drag/drop area
        '<div>' +
            '<label wj-part="g-drag"></label>' +
            '<table>' +
                '<tr>' +
                    '<td width="50%">' +
                        '<label><span class="wj-glyph wj-glyph-filter"></span> <span wj-part="g-flt"></span></label>' +
                        '<div wj-part="d-filters"></div>' +
                    '</td>' +
                    '<td width= "50%" style= "border-left-style:solid">' +
                        '<label><span class="wj-glyph">&#10996;</span> <span wj-part="g-cols"></span></label>' +
                        '<div wj-part="d-cols"></div>' +
                    '</td>' +
                '</tr>' +
                '<tr style= "border-top-style:solid">' +
                    '<td width="50%">' +
                        '<label><span class="wj-glyph">&#8801;</span> <span wj-part="g-rows"></span></label>' +
                        '<div wj-part="d-rows"></div>' +
                    '</td>' +
                    '<td width= "50%" style= "border-left-style:solid">' +
                        '<label><span class="wj-glyph">&#931;</span> <span wj-part="g-vals"></span></label>' +
                        '<div wj-part="d-vals"></div>' +
                    '</td>' +
                '</tr>' +
            '</table>' +
        '</div>' +
    '</div>' +
  
    // progress indicator
    '<div wj-part="d-prog" class="wj-state-selected" style="width:0px;height:3px"></div>' +
  
    // update panel
    '<div style="display:table">' +
        '<label style="display:table-cell;vertical-align:middle">' +
            '<input wj-part="chk-defer" type="checkbox"/> <span wj-part="g-defer"></span>' +
        '</label>' +
        '<a wj-part="btn-update" href="" draggable="false" disabled class="wj-state-disabled"></a>' +
    '</div>' +
  '</div>';
  }  
  public static updatePanelView(panel :wjOlap.PivotPanel){
    let rows= panel.hostElement.querySelectorAll(".wj-row");    
    Array.prototype.forEach.call(rows,(row:HTMLElement)=>{
      var label= row.querySelector("label");      
      if(label){
        var _txt=label.innerText,
          _fChild=label.querySelector("input");
          if(_fChild){
            label.parentElement.innerHTML="<label class='custom'><input type='checkbox' "+(_fChild.checked ? "checked >" : ">")+_txt+"<span class='checkmark'></span></label>";
         }
      }
    });
    
  }
}